/* SMTSIM simulator.
   
   Copyright (C) 1994-1999 by Dean Tullsen (tullsen@cs.ucsd.edu)
   ALL RIGHTS RESERVED.

   SMTSIM is distributed under the following conditions:

     You may make copies of SMTSIM for your own use and modify those copies.

     All copies of SMTSIM must retain all copyright notices contained within.

     You may not sell SMTSIM or distribute SMTSIM in conjunction with a
     commerical product or service without the express written consent of
     Dean Tullsen.

   THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
   IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
   WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
   PURPOSE.

 */

#include "stash.h"
#include "main.h"

#include "fetch.h"

extern context *thecontexts[];

scoreboard_t *decode_head;
scoreboard_t *decode_tail;
extern scoreboard_t *rename_head;

int num_in_decode;
extern int num_in_rename;

extern int misfetch_discovered[];

/* Pass on to the next stage, as long as it is empty */

void
decode()
{
  scoreboard_t *instrn;

  /* if rename stage clear, move previously fetched instructions to the
     rename stage
     */
  if (num_in_rename != 0) {
    DEBUGPRINTF("decode backed up\n");
    return;
  }
  num_in_rename = num_in_decode;
  rename_head = decode_head;
  for (instrn = decode_head;instrn!= NULL;instrn = instrn->next)
    {
      if (instrn->misfetch) {
	misfetch_discovered[instrn->thread] = 1;
      }
    }
  decode_head = decode_tail = NULL;
  num_in_decode = 0;
}


