/* SMTSIM simulator.
   
   Copyright (C) 1994-1999 by Dean Tullsen (tullsen@cs.ucsd.edu)
   ALL RIGHTS RESERVED.

   SMTSIM is distributed under the following conditions:

     You may make copies of SMTSIM for your own use and modify those copies.

     All copies of SMTSIM must retain all copyright notices contained within.

     You may not sell SMTSIM or distribute SMTSIM in conjunction with a
     commerical product or service without the express written consent of
     Dean Tullsen.

   THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
   IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
   WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
   PURPOSE.

Significant parts of the SMTSIM simulator were written by Gun Sirer
(before it became the SMTSIM simulator) and by Jack Lo (after it became
the SMTSIM simulator).  Therefore the following copyrights may also apply:

Copyright (C) Jack Lo
Copyright (C) E. Gun Sirer

Pieces of this code may have been derived from Jim Larus' SPIM simulator,
which contains the following copyright:

==============================================================
   Copyright (C) 1990-1998 by James Larus (larus@cs.wisc.edu).
   ALL RIGHTS RESERVED.

   SPIM is distributed under the following conditions:

     You may make copies of SPIM for your own use and modify those copies.

     All copies of SPIM must retain my name and copyright notice.

     You may not sell SPIM or distributed SPIM in conjunction with a
     commerical product or service without the expressed written consent of
     James Larus.

   THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
   IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
   WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
   PURPOSE.
===============================================================
 */

#define K    1024
#define M 1048576

typedef enum { Byte, Half, Word }  Size;
extern Segment segment[];

extern mem_addr sigtramp; /* address of the signal trampoline code */

/* mem.c */
extern mem_addr mem_address(context *, mem_addr);
extern mem_addr mem_address_nullok(context *, mem_addr);
extern mem_quad read_mem_quad(context *, mem_addr);
extern mem_word read_mem_word(context *, mem_addr);
extern mem_half read_mem_half(context *, mem_addr);
extern mem_byte read_mem_byte(context *, mem_addr);
extern void set_mem_quad(context *, mem_addr, mem_quad);
extern void set_mem_word(context *, mem_addr, mem_word);
extern void set_mem_half(context *, mem_addr, mem_half);
extern void set_mem_byte(context *, mem_addr, mem_byte);
extern void make_memory(context *, unsigned long int, unsigned long int, unsigned long int, unsigned long int, int);
extern void expand_data(context *,long);
extern void expand_stack(context *);
extern void setupstack(context *,int, int, char **, char **);

#ifndef SLOW
/* Inline this function if we are using gcc */
#ifdef __GNUC__
inline
#include "memaddr.c"
#endif
#endif

/*
 * the following macros do not call the cache update routines and can
 * be inlined across modules
 */
#define rnr_mem_quad(current, addr) *(mem_quad *)mem_address(current, addr)
#define rnr_mem_word(current, addr) *(mem_word *)mem_address(current, addr)
#define rnr_mem_half(current, addr) *(mem_half *)mem_address(current, addr)
#define rnr_mem_byte(current, addr) *(mem_byte *)mem_address(current, addr)
#define snr_mem_quad(current, addr,value) *(mem_quad*)mem_address(current, addr)=(mem_quad)value
#define snr_mem_word(current, addr,value) *(mem_word*)mem_address(current, addr)=(mem_word)value
#define snr_mem_half(current, addr,value) *(mem_half*)mem_address(current, addr)=(mem_half)value
#define snr_mem_byte(current, addr,value) *(mem_byte*)mem_address(current, addr)=(mem_byte)value

#ifndef SLOW
#define read_mem_quad(current, addr)    (rnr_mem_quad(current, addr))
#define read_mem_word(current, addr)    (rnr_mem_word(current, addr))
#define read_mem_half(current, addr)    (rnr_mem_half(current, addr))
#define read_mem_byte(current, addr)    (rnr_mem_byte(current, addr))
#define set_mem_quad(current, addr, value) (snr_mem_quad(current, addr, value))
#define set_mem_word(current, addr, value) (snr_mem_word(current, addr, value))
#define set_mem_half(current, addr, value) (snr_mem_half(current, addr, value))
#define set_mem_byte(current, addr, value) (snr_mem_byte(current, addr, value))
#endif

#define mem_address(current,addr) ((mem_addr) (((long)current->segment[addr>>28].segment)+addr-current->segment[addr>>28].base))

