/* SMTSIM simulator.
   
   Copyright (C) 1994-1999 by Dean Tullsen (tullsen@cs.ucsd.edu)
   ALL RIGHTS RESERVED.

   SMTSIM is distributed under the following conditions:

     You may make copies of SMTSIM for your own use and modify those copies.

     All copies of SMTSIM must retain all copyright notices contained within.

     You may not sell SMTSIM or distribute SMTSIM in conjunction with a
     commerical product or service without the express written consent of
     Dean Tullsen.

   THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
   IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
   WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
   PURPOSE.

Significant parts of the SMTSIM simulator were written by Jack Lo.
Therefore the following copyright may also apply:

Copyright (C) Jack Lo
 */


#ifndef _STACK_H_DEFINED
#define _STACK_H_DEFINED

#define STACKSZ      (409600+4096)
#define STACKDELTA   (409600+4096)

#define STACKCHUNKSZ (409600+4096)
#define STACKSPACESZ 8 /* Number of stack chunks */

typedef struct stack_chunk_t {
  int number;
  int free;
  int contextid;
  mem_addr base;
} StackChunk;

extern unsigned long text_start_address, data_start_address;

extern void init_stack_space();
extern mem_addr stack_allocate_contiguous(context *, unsigned long size);
extern void stack_free(mem_addr base);

#endif
