/* SMTSIM simulator.
   
   Copyright (C) 1994-1999 by Dean Tullsen (tullsen@cs.ucsd.edu)
   ALL RIGHTS RESERVED.

   SMTSIM is distributed under the following conditions:

     You may make copies of SMTSIM for your own use and modify those copies.

     All copies of SMTSIM must retain all copyright notices contained within.

     You may not sell SMTSIM or distribute SMTSIM in conjunction with a
     commerical product or service without the express written consent of
     Dean Tullsen.

   THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
   IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
   WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
   PURPOSE.

Significant parts of the SMTSIM simulator were written by Gun Sirer
(before it became the SMTSIM simulator) and by Jack Lo (after it became
the SMTSIM simulator).  Therefore the following copyrights may also apply:

Copyright (C) Jack Lo
Copyright (C) E. Gun Sirer

Pieces of this code may have been derived from Jim Larus' SPIM simulator,
which contains the following copyright:

==============================================================
   Copyright (C) 1990-1998 by James Larus (larus@cs.wisc.edu).
   ALL RIGHTS RESERVED.

   SPIM is distributed under the following conditions:

     You may make copies of SPIM for your own use and modify those copies.

     All copies of SPIM must retain my name and copyright notice.

     You may not sell SPIM or distributed SPIM in conjunction with a
     commerical product or service without the expressed written consent of
     James Larus.

   THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
   IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
   WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
   PURPOSE.
===============================================================
 */


#include "syscall.h"
/* Description of (most) MIPS system calls so SPIM can pass the correct
   arguments to the system when a user program executes a syscall in
   binary mode. */
typedef struct {
    int syscall_num;
    int syscall_type;
    int args[6];
    char *syscall_name;
} syscall_desc;

enum {BAD_SYSCALL, UNIX_SYSCALL, SPC_SYSCALL};
enum {NO_ARG, INT_ARG, ADDR_ARG, STR_ARG, FD_ARG};  /* Type of argument */

#ifdef __alpha
#define SYS_sigreturn  103
#define SYS_sigcleanup 139
#define SYS_sysmips    151
#define SYS_cacheflush 152
#define SYS_cachectl   153
#define SYS_atomic_op  155
#endif
syscall_desc syscall_table[] =
{
#include "syscalls-ultrix.h"
};
#define MAX_SYSCALL	asize(syscall_table)

#define SYSCALL_ARG(REGOFF, ARG, REG)        			             \
((syscall_table[current->R[REGOFF]].args[ARG]==ADDR_ARG)?mem_address_nullok(current,current->R[REG]) : \
 (syscall_table[current->R[REGOFF]].args[ARG]==STR_ARG)?mem_address_nullok(current,current->R[REG])  : \
 ((syscall_table[current->R[REGOFF]].args[ARG] == FD_ARG) && (current->R[REG] < MAXFDS))  ?    \
                                                   prog_fds[current->R[REG]] : current->R[REG])

